#!/usr/bin/python
# -*- encoding: utf-8 -*-

""" Codé par 20-100
script qui affiche des trucs à penser, des J-n des conneries
or that kind of stuff.

Partie serveur, prévue pour chercher périodiquement les trucs non lus
et répondre à un check.

"""

import re
from lxml import etree
import os
import sys
import urllib
import json
os.chdir('/home/vincent/scripts/today/')
sys.path.append("/home/vincent/scripts/dtc/")
import dtc

#: Config serveur
import serverconfig

#: Récupération de toutes les nouveautés
import gather

def last_dtc():
    """Vérifie si il y a des quotes DTC non lues"""
    return dtc.last_inserted()

def last_xkcd():
    p = urllib.urlopen("http://xkcd.com")
    t = p.read()
    current_id = int(re.findall("Permanent link to this comic: http://xkcd.com/(.*?)/", t)[0])
    return current_id

def last_xantah():
    p = urllib.urlopen("http://www.adoprixtoxis.com/lite/download/xantah_downloads.php")
    t = p.read()
    ids = re.findall("""<div class="top">Xantah (.*?)</div>""", t)
    ids = [int(i) for i in ids]
    return max(ids)

def last_jl8():
    rss = urllib.urlopen("http://limbero.org/jl8/rss/")
    t = rss.read()
    x = etree.fromstring(t)
    links = x.xpath("//link")
    maxnum = links[1].text.split("/")[-1]
    maxnum = int(maxnum)
    return maxnum

def get_file():
    """Récupère la liste des derniers ids de chaque truc, stockée dans le fichier."""
    f = open(serverconfig.store_published_file)
    news = json.load(f)
    f.close()
    return news

def update_file(news):
    """Met à jour la liste des derniers ids dans le fichier."""
    f = open(serverconfig.store_published_file, 'w')
    json.dump(news, f)
    f.close()

FETCHS = {
          "xkcd" : last_xkcd,
          "dtc" : last_dtc,
          "xantah" : last_xantah,
          "dc" : last_jl8,
         }

def fetch_all():
    """Va chercher sur les différents sites les nouveaux trucs."""
    news = {}
    for (k, f) in FETCHS.iteritems():
        try:
            news[k] = f()
        except Exception as e:
            raise
    news.update(gather.gather())
    return news

def sync():
    """Reçoit une requête de synchronisation."""
    # On récupère où en est le client sur stdin
    t = sys.stdin.read()
    on_client = json.loads(t)
    # On récupère où en est le serveur dans le fichier idoine
    if os.path.isfile(serverconfig.store_seen_file):
        on_server = json.load(open(serverconfig.store_seen_file))
    else:
        on_server = {}
    # On garde le maximum
    for k in set(on_client.keys() + on_server.keys()):
        on_server[k] = max(on_client.get(k, 0), on_server.get(k, 0))
    # On enregistre ce nouveau dico
    json.dump(on_server, open(serverconfig.store_seen_file, "w"))
    # On envoie au client ce nouveau dico
    print json.dumps(on_server)

if __name__ == "__main__":
    DEBUG = ("--debug" in sys.argv) or ("--verbose" in sys.argv) or serverconfig.DEBUG
    if sys.argv[1] == "check":
        news = fetch_all()
        if "--init" in sys.argv:
            olds = news
        else:
            olds = get_file()
            olds.update(news)
        update_file(olds)
    elif sys.argv[1] == "whatsup":
        news = get_file()
        print json.dumps(news)
    elif sys.argv[1] == "sync":
        sync()
